from typing import Any, Dict, List, Type, TypeVar, cast

import attr

T = TypeVar("T", bound="QueryFilesResponse")


@attr.s(auto_attribs=True)
class QueryFilesResponse:
    """
    Attributes:
        file_urls (List[str]):
    """

    file_urls: List[str]
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        file_urls = self.file_urls

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "fileUrls": file_urls,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        file_urls = cast(List[str], d.pop("fileUrls"))

        query_files_response = cls(
            file_urls=file_urls,
        )

        query_files_response.additional_properties = d
        return query_files_response

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
